/*
				PCM-AIO
     This program was written Primarily as a test/setup procedure
     for the PCM-AIO board. (400-0172-000)
	It also demonstrates how to access the MAX181 part,
     and shows various methods of accessing the part.
     Use getconv() for real-time readings in the foreground.
     Use the Interrupt driven method to provide an array image
     of all eight channels, constantly updated in the background.

     Date: 03-01-1993.
     Author: John Keller
       Copyright 1992 by Winsystems. All Rights Reserved.
*/



#include<stdio.h>
#include<dos.h>
#include<stdlib.h>
#include<graph.h>

#define     A2DBASE	0x100

void (_interrupt _far *OldTmr)();	/* Pointer to old ISR */
void (_interrupt _far *TmrPtr)();	/* Temporary ISR Pointer */
void interrupt Int1c(void);		/* Declaration on ISR */

void (_interrupt _far *OldRq5)();	/* Pointer to old ISR */
void (_interrupt _far *Rq5Ptr)();	/* Temporary ISR Pointer */
void interrupt Int0d(void);		/* Declaration on ISR */

unsigned int ticks[5],convi;
unsigned int tar[8] = {0x000,0x924,0x249,0xb6d,0x492,0xdb6,0x6db,0xfff};

main()
{
int a,b,c;
    for(a=0; a<50;a++)
	printf("                                        \n");
    _settextposition(1,1);
    printf("Test for PCM-AIO boards\n");
    printf("System should be on for 5 minutes before calibrating.\n");
    printf("     To set up the A/D, connect the Voltage Source to the points\n");
    printf(" indicated on the test fixture and set for 4.998 Volts.\n");
    printf(" Adjust R3 until channel 0 %'Read%' is switching between 0 & 1.\n");
    printf(" Next, Adjust R2 until channel 7 %'Read%' is FFE.\n");
    printf(" Increase to 5.000 Volts. Ch 7 %'Read%' should now be FFF. Ch 0 %'Read%' should\n");
    printf(" still be between 0 and 1.\n");
    printf(" All channels should display PASS. You should NOT see the messages\n");
    printf(" %'Interrupt Failed%',  or  %'Busy is Stuck%' below the channels.\n");
    printf(" Calibrate D/A:\n");
    printf(" Adjust R13 for 5.000 Volts at J6(1). Set Full Scale by pressing 1.\n");
    printf(" Adjust R1 for 4.9988 Volts at J3(2). Adjust R18 for 4.9988V at J3(8).\n");
    printf(" Test D/A:\n");
    printf(" Press 2 for half scale, 3 for 1/4 scale, 4 for 3/4 scale, 0 for zero.\n");

    OldRq5 = _dos_getvect(0x0d);
    OldTmr = _dos_getvect(0x1c);
    TmrPtr = Int1c;
    Rq5Ptr = Int0d;
    _dos_setvect(0x1c,TmrPtr);
    _dos_setvect(0x0d,Rq5Ptr);
    _displaycursor(_GCURSOROFF);
    a = inp(0x21);
    a &= 0xdf;		    /*unmask irq5 */
    outp(0x21,a);
    _settextposition(16,10);
    printf("Ch Trgt Read Difference");
    while(1)
    {
	for(a=0; a<8; a++)	/* Scan all channels */
	{
	    c=getconv(a,0);	/* Channel a, single ended, Unipolar */
	    _settextposition(a+17,10);
	    printf("%2d %3X %3X %3X",a,tar[a],c,abs(c-tar[a]));
	    if(c > tar[a])
		putch('-');
	    if(c < tar[a])
		putch('+');
	    if(c == tar[a])
		putch(' ');
	    printf(" %3d%% ",abs(c-tar[a]) / 41);
	    if(a >0 && a <7)
	    {
		if(abs(c-tar[a])<40)	/*1% resistors used for testing.*/
		    printf("Pass");
		else
		    printf("Fail");
	    }
	    if(a == 0 || a == 7)
	    {
		if(abs(c-tar[a])<2)	/*used for offset/gain calibration*/
		    printf("Pass");
		else
		    printf("Fail");
	    }
	}
	if(kbhit())
	{
	    a = getch();
	    if(a == '0')
	    {
		outp(A2DBASE+0x08,0x00);
		outp(A2DBASE+0x09,0x00);
		outp(A2DBASE+0x0a,0x00);
		outp(A2DBASE+0x0b,0x00);
	    }
	    else
		if(a == '1')
		{
		    outp(A2DBASE+0x08,0xff);
		    outp(A2DBASE+0x09,0x0f);
		    outp(A2DBASE+0x0a,0xff);
		    outp(A2DBASE+0x0b,0x0f);
		}
	    else
		if(a == '2')
		{
		    outp(A2DBASE+0x08,0x00);
		    outp(A2DBASE+0x09,0x08);
		    outp(A2DBASE+0x0a,0x00);
		    outp(A2DBASE+0x0b,0x08);
		}
	    else
		if(a == '3')
		{
		    outp(A2DBASE+0x08,0x00);
		    outp(A2DBASE+0x09,0x04);
		    outp(A2DBASE+0x0a,0x00);
		    outp(A2DBASE+0x0b,0x04);
		}
	    else
		if(a == '4')
		{
		    outp(A2DBASE+0x08,0xff);
		    outp(A2DBASE+0x09,0x0b);
		    outp(A2DBASE+0x0a,0xff);
		    outp(A2DBASE+0x0b,0x0b);
		}
	    else
		break;
	}
    }
    a = inp(0x21);
    a |= 0x20;		    /*mask irq5 */
    outp(0x21,a);
    _displaycursor(_GCURSORON);
    _dos_setvect(0x0d,OldRq5);
    _dos_setvect(0x1c,OldTmr);
}
/* Get conversion. */
/* MODE:
    0	Single ended, Unipolar.
    1	Single ended, Bipolar.
    2	Differential, Unipolar.
    3	Differential, Bipolar.
NOTE:
    In Differential mode, valid channels are still 0-7, however,
    the channels are paired, evens with odds. (I.E. 0 with 1, 2 with 3,
    etc.) The channel read becomes the "+" leg for the reading.
	Example:
	    Channel 0 is 1.500 Volts lower than channel 1.
	    Mode is 2.
	    Channel read is 1.
	    Result: 1228(d) = 4CC(h).
	    If channel 0 had been read, the result would be zero.
*/
int getconv(int ch,int mode)
{
unsigned int a,b,c;
    convi=0;
    mode &= 3;
    mode = mode << 3;
    mode |= ch;
    outp(A2DBASE+0,mode);
    ticks[0] = 2;
    while(ticks[0] && (inp(A2DBASE+4) & 0x80));
    if(ticks[0] == 0)
    {
	_settextposition(22,60);
	printf("Busy is stuck.\n");
    }
    if(convi == 0)
    {
	_settextposition(23,60);
	printf("Interrupt Failed");
    }
    a = inp(A2DBASE+0) & 255;
    b = inp(A2DBASE+1) & 15;
    c = (b<<8) | a;
    return(c);
}

/* Timer Tick Interrupt */
void interrupt Int1c(void)
{
int a;
    for(a=0; a<5; a++)
    {
	if(ticks[a] > 0)
	    ticks[a]--;
    }
}


/* A2D Interrupt from SBX */
void interrupt Int0d(void)
{
    convi++;	/* Used by test. */


/*	SAMPLE APPLICATION */
/*	Read All Eight Channels as Single ended/UniPolar & store in integer
	Array variable results[8]. */

/*  read & store the result.*/
/*  result[channel] = inp(A2DBASE+0) | ((inp(A2DBASE+1)&15)<<8);*/

/*  Start next conversion */
/*  ++channel &= 7;*/
/*  outp(A2DBASE+0,channel);*/


    outp(0x20,0x20);	/* Non-Specific EOI */
}
